# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%bcond_with test
%bcond_with bootstrap
%bcond_without repolib

%define reltag _redhat_3
%define namedreltag -redhat-3
%global namedversion %{version}%{?namedreltag}

%define section free

Name:           xom
Version:        1.2.7
Release:        1.%{?reltag}.1%{?dist}.6
Epoch:          0
Summary:        XML Pull Parser
License:        LGPLv2+
URL:            http://www.xom.nu/
Group:          Text Processing/Markup/XML
%if 0
svn -q export -r 2088 https://svn.java.net/svn/xom~svn/tags/XOM_127 xom-1.2.7 && tar cjf xom-1.2.7.tar.bz2 xom-1.2.7
http://www.cafeconleche.org/XOM/xom-1.2.7-src.tar.gz
%endif
Source0:        xom-1.2.7.tar.bz2
Source1:        http://repo1.maven.org/maven2/xom/xom/1.2.7/xom-1.2.7.pom
Patch0:         xom-build.patch
Patch1:         xom-1.1-clean-dist.patch
Patch2:         xom-crosslink.patch
Patch3:         xom-1.2b2-javadoc-stack-size.patch
Patch4:         xom-vman-pom.patch
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jaxen
Requires:       jpackage-utils
Requires:       xalan-j2
Requires:       xerces-j2
BuildRequires:  java-devel >= 0:1.5
BuildRequires:  ant >= 0:1.6
BuildRequires:  ant-junit
BuildRequires:  java-javadoc
BuildRequires:  jarjar
BuildRequires:  jaxen
BuildRequires:  junit
BuildRequires:  junit-javadoc
BuildRequires:  xalan-j2
BuildRequires:  xerces-j2
BuildRequires:  xml-commons-jaxp-1.3-apis
%if %without bootstrap
BuildRequires:  tagsoup
BuildRequires:  saxon
BuildRequires:  jaxp_parser_impl
BuildRequires:  xml-commons-resolver12
BuildRequires:  servlet_api
%endif
%if %with repolib
BuildRequires:  maven2-plugin-deploy
BuildRequires:  jboss-parent
%endif
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
XOM is a new XML object model. It is an open source (LGPL), 
tree-based API for processing XML with Java that strives 
for correctness, simplicity, and performance, in that order. 
XOM is designed to be easy to learn and easy to use. It 
works very straight-forwardly, and has a very shallow 
learning curve. Assuming you're already familiar with XML, 
you should be able to get up and running with XOM very quickly.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q
%{_bindir}/find -type f \( -name "*.jar" -o -name "*.class" -o -name "*.zip" \) | %{_bindir}/xargs -t %{__rm}
cp -p %{SOURCE1} xom-%{version}.pom
%patch0 -p1 -b .sav0
%patch1 -p1 -b .sav1
%patch2 -p1 -b .sav2
%patch3 -p1 -b .sav3
%patch4 -p1 -b .sav4
%{__perl} -pi -e 's/\r$//g' *.html *.txt
%{__perl} -pi -e 's/compress="no"/compress="yes"/g' build.xml

%build
export LANG=en_US.UTF-8
export CLASSPATH=`%{_bindir}/build-classpath jaxen`
export OPT_JAR_LIST="`%{__cat} %{_sysconfdir}/ant.d/junit`"
export ANT_OPTS="-Xss1m"
pushd lib
%{__ln_s} `%{_bindir}/build-classpath xercesImpl` dtd-xercesImpl.jar
%{__ln_s} `%{_bindir}/build-classpath jarjar` jarjar-1.0.jar
%{__ln_s} `%{_bindir}/build-classpath junit` junit.jar
%{__ln_s} `%{_bindir}/build-classpath serializer` serializer.jar
%{__ln_s} `%{_bindir}/build-classpath xalan` xalan.jar
%{__ln_s} `%{_bindir}/build-classpath xml-commons-jaxp-1.3-apis` xml-apis.jar
popd
mkdir lib2
%if %without bootstrap
pushd lib2
%{__ln_s} `%{_bindir}/build-classpath tagsoup` tagsoup-1.2.jar
%{__ln_s} `%{_bindir}/build-classpath saxon` saxon.jar
# XXX: saxon-aelfred.jar
%{__ln_s} `%{_bindir}/build-classpath jaxp_parser_impl` gnujaxp.jar
%{__ln_s} `%{_bindir}/build-classpath xml-commons-resolver12` resolver.jar
DOM4J_PRESENT=`%{_bindir}/build-classpath dom4j 2>/dev/null || :`
if [ -n "$DOM4J_PRESENT" ]; then
%{__ln_s} `%{_bindir}/build-classpath dom4j` dom4j-1.5.1.jar
fi
%{__ln_s} `%{_bindir}/build-classpath servlet_api` servlet.jar
popd
%endif

%{ant} -Dversionqualifier=%{?namedreltag} -Dbuild.sysclasspath=first -Dj2se.api=%{_javadocdir}/java -Djunit.api=%{_javadocdir}/junit javadoc
%if %without bootstrap
%{ant} -Dversionqualifier=%{?namedreltag} -Dbuild.sysclasspath=first samples
%if %with test
%{ant} -Dversionqualifier=%{?namedreltag} -Dbuild.sysclasspath=first test
%endif
%{ant} -Dversionqualifier=%{?namedreltag} -Dbuild.sysclasspath=first zip tar.gz
%else
%{ant} -Dversionqualifier=%{?namedreltag} -Dbuild.sysclasspath=first jar
%endif

%install
%{__rm} -rf %{buildroot}

# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%{__cp} -p dist/xom-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}.jar
%if %without bootstrap
%{__cp} -p build/xom-samples.jar %{buildroot}%{_javadir}/%{name}-samples-%{namedversion}.jar
%endif
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}.jar; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} "s|-%{namedversion}||g"`; done)

# poms
%{__mkdir_p} %{buildroot}%{_mavenpomdir}
%{__cp} -p xom-%{version}.pom %{buildroot}%{_mavenpomdir}/JPP-%{name}.pom
%add_to_maven_depmap xom xom %{namedversion} JPP %{name}

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__cp} -pr build/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__ln_s} %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}

%if %with repolib
# repolib
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export URL=file://%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
#export MAVEN_OPTS="-Xms1g -Xmx1g"
%{_bindir}/mvn-jpp deploy:deploy-file -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DpomFile=%{buildroot}%{_mavenpomdir}/JPP-%{name}.pom -Dfile=%{buildroot}%{_javadir}/%{name}-%{namedversion}.jar -DrepositoryId=jboss-releases-repository -Durl=${URL}
# FIXME: hack
%{__mv} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/xom/xom/1.1/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/xom/xom/%{namedversion} || :
%{__rm} -rf %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/xom/xom/1.1
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc overview.html README.txt LICENSE.txt Todo.txt lgpl.txt
%{_javadir}*/%{name}-%{namedversion}.jar
%{_javadir}*/%{name}.jar
%if %without bootstrap
%{_javadir}*/%{name}-samples-%{namedversion}.jar
%{_javadir}*/%{name}-samples.jar
%endif
%{_mavenpomdir}/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Sun Oct 14 2012 Paul Gier <pgier@redhat.com> - 0:1.2.7-1._redhat_2.1.6
- Minor pom dependency fix

* Sat Aug 18 2012 Paul Gier <pgier@redhat.com> - 0:1.2.7-1._redhat_2.1.5
- Update pom patch for eap 6.0.1

* Tue Aug 14 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.2.7-1._redhat_2.1.4
- Rebuild unsigned

* Thu Jul 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.2.7-1._redhat_1.1.3
- Rebuild using cache signing

* Thu Jul 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.2.7-1._redhat_1.1.2
- Rebuild using cache signing

* Mon Mar 26 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.2.7-1._redhat_1.1.1
- Rebuild using cache signing

* Tue Feb 14 2012 Fernando Nasser <fnasser@redhat.com> 0:1.2.7-1.1
- Do not require JAXP at run-time (provided)

* Thu Dec 29 2011 Lin Gao <lgao@redhat.com> 0:1.2.7-0.4
- update pom to use jboss-parent:8-redhat-1

* Mon Nov 21 2011 David Walluck <dwalluck@redhat.com> 0:1.2.7-0.3
- set LANG

* Mon Nov 21 2011 David Walluck <dwalluck@redhat.com> 0:1.2.7-0.2
- rebuild to fix repolib

* Tue Nov 15 2011 David Walluck <dwalluck@redhat.com> 0:1.2.7-0.1
- 1.2.7
- add repolib

* Tue Mar 10 2009 David Walluck <dwalluck@redhat.com> 0:1.2.1-1
- 1.2.1

* Wed Aug 06 2008 David Walluck <dwalluck@redhat.com> 0:1.2-0.b2.4
- add crosslink patch

* Wed Aug 06 2008 David Walluck <dwalluck@redhat.com> 0:1.2-0.b2.3
- add ANT_OPTS and patch for javac and javadoc stack size, respectively

* Mon Aug 04 2008 David Walluck <dwalluck@redhat.com> 0:1.2-0.b2.2
- add maven support

* Mon Aug 04 2008 David Walluck <dwalluck@redhat.com> 0:1.2-0.b2.1
- 1.2b2

* Mon Aug 04 2008 David Walluck <dwalluck@redhat.com> 0:1.1-5
- BuildRequires: dom4j
- BuildRequires: saxon7
- don't use classpathx-jaxp

* Tue Jul 29 2008 David Walluck <dwalluck@redhat.com> 0:1.1-4
- fix License

* Sat Jul 26 2008 David Walluck <dwalluck@redhat.com> 0:1.1-3
- remove spurious BuildRequires: classpathx-jaxp
- remove javadoc scriptlets
- update License
- update BuildRoot
- GCJ fixes
- properly unpack sources
- fix maven directory ownership
- add ant-junit to OPT_JAR_LIST
- add ant-trax to OPT_JAR_LIST

* Tue Jun 24 2008 Fernando Nasser <fnasser@redhat.com> - 0:1.1-2
- Add missing dependency on ant-trax

* Thu Jan 31 2008 Ralph Apel <r.apel at r-apel.de> - 0:1.1-1jpp
- 1.1
- Add pom and depmap frags

* Wed May 09 2007 Ralph Apel <r.apel at r-apel.de> - 0:1.0-5jpp
- Make Vendor, Distribution based on macro

* Mon Feb 12 2007 Ralph Apel <r.apel at r-apel.de> - 0:1.0-4jpp
- Add option to build core on bootstrap
- Add gcj_support option

* Tue Feb 28 2006 Fernando Nasser <fnasser@redhat.com> - 0:1.0-3jpp
- Remove dependency on clover10 (non-free)

* Sun Feb 26 2006 Fernando Nasser <fnasser@redhat.com> - 0:1.0-2jpp
- First JPP 1.7 release

* Wed Aug 17 2005 Ralph Apel <r.apel at r-apel.de> - 0:1.0-1jpp
- First JPP release
